package cn.net.cpzslibs.prot.handset.newProt;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20063ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20063ResBean;

public class Prot20063CheckYunCarNumber  extends ProtBase {

	private final short iTaskCode20063 = 20063;
	private Gson gson;
	private Prot20063ResBean resBean;
	
	public Prot20063ResBean getResBean(){
		return this.resBean;
	}

	public Prot20063CheckYunCarNumber() {
		gson = new Gson();
	}
	public void  dealCarNo(SocketCreate create, Prot20063ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}

	private void recProt(Socket socket, DataOutputStream dos, DataInputStream dis, Prot20063ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode20063, "开始提交数据");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recDis(dis);
			}
		}
	}

	static int cTest = 0;

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20063, (cTest++) + "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20063, jsonData);
		resBean = gson.fromJson(jsonData, Prot20063ResBean.class);
		recCheckCode(dis);
		
	}

	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot20063ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		debugLog(iTaskCode20063, "发送的数据：" +bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20063, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}


